#!/bin/sh

# 
JKS_IDENTITY_STORE_FILE=$1-identity.jks
JKS_IDENTITY_STORE_PASS=jksstorepass

JKS_TRUST_STORE_FILE=$1-trust.jks
JKS_TRUST_STORE_PASS=jksstorepass

CERT_ALIAS=$1
CERT_DN="CN=ICS_$1, OU=$1:skat, O=Skat, C=DK"
CERT_PASS=$2

CERT_ALIAS_SSL=$1ssl

PUB_KEY_FILE="$1-pub.cer"

echo "Generating identity keystore for $1..."
if [ -e $JKS_IDENTITY_STORE_FILE ]; then
	rm -rf $JKS_IDENTITY_STORE_FILE
fi

keytool -genkey -keystore $JKS_IDENTITY_STORE_FILE -storepass $JKS_IDENTITY_STORE_PASS -alias $CERT_ALIAS -keypass $CERT_PASS -keyalg RSA -dname "$CERT_DN" -validity 1095

keytool -genkey -keystore $JKS_IDENTITY_STORE_FILE -storepass $JKS_IDENTITY_STORE_PASS -alias "$CERT_ALIAS_SSL" -keypass $CERT_PASS -keyalg RSA -dname "$CERT_DN" -validity 1095

if [ -e $PUB_KEY_FILE ]; then
        rm -rf $PUB_KEY_FILE
fi

echo "Exporting public key...."
keytool -export -keystore $JKS_IDENTITY_STORE_FILE -storepass $JKS_IDENTITY_STORE_PASS -alias $CERT_ALIAS -file $PUB_KEY_FILE

echo "Listing identity keystore...."
keytool -list -keystore $JKS_IDENTITY_STORE_FILE -storepass $JKS_IDENTITY_STORE_PASS

echo "Viewing certificate..."
keytool -printcert -file $PUB_KEY_FILE

echo "Generating trust keystore for $1..."
if [ -e $JKS_TRUST_STORE_FILE ]; then
	rm -rf $JKS_TRUST_STORE_FILE
fi

keytool -genkey -keystore $JKS_TRUST_STORE_FILE -storepass $JKS_TRUST_STORE_PASS -alias "dummy" -keypass $CERT_PASS -keyalg RSA -dname "$CERT_DN" -validity 1095

# Delete the dummy key!
keytool -delete -keystore $JKS_TRUST_STORE_FILE -storepass $JKS_TRUST_STORE_PASS -alias "dummy"

echo "Listing identity keystore...."
keytool -list -keystore $JKS_TRUST_STORE_FILE -storepass $JKS_TRUST_STORE_PASS

echo "IMPORTANT: This script created keys with a validity period of 3 years from date of creation! Make a note in your calendar!!"

